function cover_art_url(artist, album, size, cb) {
	if (typeof artist !== 'string') {
		throw new Error('Expected a string');
	}
	if (typeof album === 'function') {
		cb = album;
		album = size = null;
	} else if (typeof size === 'function') {
		cb = size;
		size = null;
	}

	var data = '';
	var sizes = ['small', 'medium', 'large', 'extralarge', 'mega'];
	var method = (album === null) ? 'artist' : 'album';
	var apiKey = '7f507472c5ad05c11877ab2927781582';
	var artist = artist.replace ("&", "and");
	var  host ="http://ws.audioscrobbler.com" + encodeURI('/2.0/?format=json&api_key=' + apiKey + '&method=' + method + '.getinfo&artist=' + artist + '&album=' + album)

	$.getJSON(host, function(json){

	    if (typeof(json.error) !== 'undefined'){
	    	// Error
	    	return cb('JSON Error: ' + json.message, '');
	    } else if (sizes.indexOf(size) !== -1 && json[method] && json[method].image){
	    	// Return image in specific size
	    	json[method].image.forEach(function(e, i) {
	    		if (e.size === size){
	    			cb(null, e['#text']);
	    		}
	    	});
	    } else if (json[method] && json[method].image) {
	    	// Return largest image
	    	var i = json[method].image.length - 2;
	    	cb(null, json[method].image[i]['#text']);
	    } else {
	    	// No image art found
	    	cb('Error: No image found.', '');
	    }
        });
}
