/* ympd
   (c) 2013-2014 Andrew Karpow <andy@ndyk.de>
   This project's homepage is: http://www.ympd.org
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <string.h>
#include "http_server.h"
#include "config.h"

int callback_http(struct mg_connection *c)
{
    const struct embedded_file *req_file;

    if(!strcmp(c->uri, "/"))
        req_file = find_embedded_file("/index.html");
    else
        req_file = find_embedded_file(c->uri);

    if(req_file) {
        mg_send_header(c, "Content-Type", req_file->mimetype);
        mg_send_data(c, req_file->data, req_file->size);
        return MG_TRUE;
    } else if (!strncmp(c->uri, "/", 1) && !strncmp(c->uri + 2, "/", 1)) {
        /* command exec */
        FILE* fp;
        size_t len = 0;
        char  cmd[256];
        char  buf[4096];
        char  rw[1];
        buf[0] = '\0';
        strncpy(rw, c->uri + 1, 1);

        sprintf(cmd, "/home/pi/misc/ympd_event.sh %s \"%s\" \"%s\"",
            rw,
            c->uri == NULL ? "" : c->uri + 2,
            c->query_string == NULL ? "" : c->query_string
        );
        if ((fp = popen(cmd, "r")) != NULL) {
            while (fgets(buf + len, sizeof(buf - len), fp)) {
                len = strlen(buf);
                if (len > 0 && buf[len - 1] == '\n') {
                    buf[--len] = '\0';
                }
            }
            pclose(fp);
        }

        /* return stdout */
        mg_send_header(c, "Content-Type", "application/json");
        mg_send_data(c, buf, len);
	return MG_TRUE;
    }
#ifdef WITH_DYNAMIC_ASSETS
    return MG_FALSE;
#else
    mg_send_status(c, 404);
    mg_printf_data(c, "Not Found");
    return MG_TRUE;
#endif

}
